/* usersem test: up and down a lot */
#include <sys/mman.h>
#include <sys/types.h>

#include <unistd.h>
#include <stdio.h>

#include "usersem.h"

#define	COUNT	1000000

int main(void)
{
	struct fast_sem *sem;
	void *map;
	int i;
	int *f;

	map = mmap(0, 4096, PROT_READ|PROT_WRITE, MAP_SHARED|MAP_ANON, -1, 0);
	if(map == MAP_FAILED) {
		perror("shared anon mmap failed");
		return 1;
	}

	sem = (struct fast_sem*)map;
	f = (int*)(map + sizeof(*sem));
	*f = 0;

	/* start unlocked */
	fs_create(sem);

	if(fork() < 0) {
		perror("fork failed");
		return 1;
	}

	for(i = 0; i < COUNT; i++) {
		fs_down(sem);
		(*f)++;
		fs_up(sem);
	}

	printf("final f=%d\n", *f);
	return 0;
}
