/* usersem test: multiple blocked processes */
#include <sys/mman.h>
#include <sys/types.h>

#include <unistd.h>
#include <stdio.h>

#include "usersem.h"

#define	COUNT	10

int main(void)
{
	struct fast_sem *sem;
	void *map;
	int i;

	map = mmap(0, 4096, PROT_READ|PROT_WRITE, MAP_SHARED|MAP_ANON, -1, 0);
	if(map == MAP_FAILED) {
		perror("shared anon mmap failed");
		return 1;
	}

	sem = (struct fast_sem*)map;

	/* start locked */
	fs_create(sem);
	fs_down(sem);

	for(i = 0; i < COUNT; i++) {
		switch(fork()) {
		case -1: perror("fork failed"); return 1;
		case 0:	fs_down(sem);
			printf("child %d woke up\n", i);
			return 0;
		}
	}

	sleep(3);

	for(i = 0; i < COUNT; i++) {
		printf("wake up #%d\n", i);
		fs_up(sem);
		sleep(1);
	}

	return 0;
}
