/* usersem test: shared/anon mapped semaphore */
#include <sys/mman.h>
#include <sys/types.h>

#include <unistd.h>
#include <stdio.h>

#include "usersem.h"

int main(void)
{
	struct fast_sem *sem;
	void *map;
	int *f;

	map = mmap(0, 4096, PROT_READ|PROT_WRITE, MAP_SHARED|MAP_ANON, -1, 0);
	if(map == MAP_FAILED) {
		perror("shared anon mmap failed");
		return 1;
	}

	sem = (struct fast_sem*)map;
	f = (int*)(map + sizeof(*sem));
	*f = 0;

	/* start locked */
	fs_create(sem);
	fs_down(sem);

	switch(fork()) {
	case -1:
		perror("fork failed");
		return 1;
	default:
		puts("parent: lock");
		fs_down(sem);
		printf("parent: f = %d\n", *f);
		puts("parent: got lock");
		puts("parent: lock");
		fs_down(sem);
		puts("parent: got lock");
		alarm(5);
		puts("parent: lock");
		fs_down(sem);		/* blocks */
		puts("parent: got lock");
		break;
	case 0:
		sleep(5);
		printf("child: set f = %d\n", *f = 5);
		puts("child: unlock");
		fs_up(sem);
		puts("child: unlocked");
		puts("child: unlock");
		fs_up(sem);
		puts("child: unlocked");
	}
	return 0;
}
